Description

In QGIS 2.12, having a Postgis table with Z component. It's not possible to add a new features, as it fails to save. Yet, It's possible to edit

or copy/paste existing features.

The issue can be replicated by doing the following:

Creating a table in Postgis:

CREATE TABLE test

(

  gid serial primary key,

  name character varying(100),

  geom geometry(MultiPolygonZ,4326)

);

Insert a record:

INSERT INTO test (name,geom) VALUES 

('polygon 1 single flat', ST_GeomFromText('MultiPolygonZ (((-30.0 42.0 0, -30.0 41.0 0, -29.0 41.0 0, -29.0 42.0 0, -30.0 42.0

0)))',4326));

Open the table in QGIS, start editing and create a new feature.

Trying to save the edits you will get the following error:

Could not commit changes to layer test

  Errors: ERROR: 1 feature(s) not added.

    Provider errors:

        PostGIS error while adding features: ERRO:  Column has Z dimension but geometry does not

If you copy paste the features to notepad, you notice that the geometry of the created feature lacks the Z component.

Also, it's impossible to edit the Z component with the new node editor.

This was already happening in QGIS 2.8.

History

#1 - 2015-12-20 04:22 PM - Pedro Venâncio
I can confirm this issue. Some information about it with sample data:

http://osgeo-org.1560.x6.nabble.com/Problem-editing-and-exporting-3D-Postgis-layers-td5240800.html

#2 - 2017-05-01 01:06 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#3 - 2017-09-08 01:35 PM - Jürgen Fischer

- Assignee deleted (Jürgen Fischer)

#4 - 2017-10-04 03:50 PM - Giovanni Manghi

- Resolution set to fixed/implemented

- Description updated

- Status changed from Open to Closed

This particular problem (adding a new feature) seems solved in 2.18.13 and master. There are others anyway in 2.18 that are not there in 2.14 and master:

existing line/polygon features cannot be moved, the node tool is not able to move vertexes and the Z value of nodes cannot be changed.

Will file a new ticket.
